

#include <stdlib.h>
#include <stdio.h>
#include <strings.h>
#include <sys/timeb.h>
#include <math.h>


#define MAX_LENGTH 256
#define MAX_SAMPLE 50

/* data structures ... (ha ha)
 */
typedef unsigned char Bool;
#define TRUE 1
#define FALSE 0



/* commands
 */
char *gparam;
int gup;



/* command line
 */
void usage( void );
Bool process_command_line( int argc, char *argv[] );



int main( int argc, char *argv[] )

{

  FILE *data;

  int nr;
  char filename[256];
  char oneline[256];

  float value;

  Bool found;

  gparam = NULL;
  gup = -1;


  if ( !process_command_line( argc, argv ) ) {
    usage();
    exit( 1 );
  }


  for ( nr = 1; nr <= gup; nr++ ) {
    if ( nr < 10 ) {
      sprintf( filename, "p0%d.soln", nr);
    } else {
      sprintf( filename, "p%d.soln", nr);
    }

    if ( (data = fopen( filename, "r")) == NULL ) {
      printf("\n");
      continue;
    }
    
    found = FALSE;
    while ( 1 ) {
      if ( fscanf( data, "%s", oneline) == EOF ) break;
      if ( strcmp( oneline, gparam ) == 0 ) {
	if ( fscanf( data, "%f", &value) != 1 ) {
	  printf("\n\nerror: file %s does not contain value for parameter!\n\n", filename);
	  exit( 1 );
	} else {
	  found = TRUE;
	  break;
	}
      }
    }
    if ( !found ) {
      printf("\n\nerror: file %s does not contain parameter!\n\n", filename);
      exit( 1 );
    } else {
      printf("%d %f\n", nr, value);
    }
  }

  exit( 0 );

}



void usage( void )

{

  printf("\nusage:\n");

  printf("\nOPTIONS   DESCRIPTIONS\n\n");
  printf("-p <str>    name of parameter to be extracted\n");
  printf("-u <num>    uppermost task number\n\n");

}



Bool process_command_line( int argc, char *argv[] )

{

  char option;

  while ( --argc && ++argv ) {
    if ( *argv[0] != '-' || strlen(*argv) != 2 ) {
      return FALSE;
    }
    option = *++argv[0];
    switch ( option ) {
    default:
      if ( --argc && ++argv ) {
	switch ( option ) {
	case 'p':
	  gparam = ( char * ) calloc( MAX_LENGTH, sizeof( char ) );
	  strncpy( gparam, *argv, MAX_LENGTH );
	  break;
	case 'u':
	  sscanf( *argv, "%d", &gup );
	  break;
	default:
	  printf( "\n\nunknown option: %c entered\n\n", option );
	  return FALSE;
	}
      } else {
	return FALSE;
      }
    }
  }

  if ( !gparam ||
       gup == -1 ) {
    return FALSE;
  }

  return TRUE;

}
